=== debian/control ===
Source: reflection-cpp
Priority: optional
Maintainer: April Lu <apr3vau@outlook.com>
Build-Depends: debhelper-compat (= 13), cmake
Standards-Version: 4.6.0
Section: libs
Homepage: https://github.com/contour-terminal/reflection-cpp
Rules-Requires-Root: no

Package: libreflection-cpp-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}
Description: C++ static reflection support library
 This is a C++ static reflection library.
